<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto modifications Copyright 2004-2007 Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 1.3.7 - Last modified 4/03/2007
*/


// Load bootstrap
// Note: cookies may not work with POST data!
if (isset ($_POST['OekakiU']) && isset ($_POST['OekakiPass'])) {
	$OekakiU    = $_POST['OekakiU'];
	$OekakiPass = $_POST['OekakiPass'];
} else {
	$OekakiU    = $_COOKIE['OekakiU'];
	$OekakiPass = $_COOKIE['OekakiPass'];
}
$no_template = TRUE;
$no_online = TRUE;
$mail_sent = FALSE;
define ('BOOT', 1);
require ('boot.php');


// Redirect with page number and sort.
$pic_redirect = '';
if ($_REQUEST['pageno'] || $_REQUEST['sort'] || $REQUEST['artist']) {
	$pic_redirect = '?pageno='.intval($_REQUEST['pageno']);
	if (intval($_REQUEST['sort'])) {
		$pic_redirect .= '&sort='.intval($_REQUEST['sort']);
	}
	if ($_REQUEST['artist']) {
		$pic_redirect .= '&artist='.urlencode($_REQUEST['artist']);
	}
}



// ==================================================================
// Functions specific to this file
//
function check_php_code($text) {
	global $dbconn;

	if (defined ('DISABLE_PHP_RESOURCE') && DISABLE_PHP_RESOURCE == 1) {
		if (strpos ($text, '<?') !== FALSE) {
			report_err('PHP code has been disabled in the notice, banner, and rules.');
		}
	}
	return TRUE;
}

function html_chars_wac($in) {
	return (htmlspecialchars (trim ($in), ENT_NOQUOTES));
}



// ==================================================================
// Process login
//

// Login (from header.php)
if ($action == 'login') {
	$username = slashit($_POST['username']);
	$pass     = slashit($_POST['pass']);
	$usrpass3 = crypt ($pass, $cfg['salt']);

	$result = mysql_query ("SELECT usrname, usrpass, usrflags FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");

	if ($result) {
		$row = mysql_fetch_array ($result);

		//check if passwords are correct and that the user is a non-pending member
		if (($usrpass3 == $row['usrpass']) && !strstr ($row['usrflags'], 'P')) {
			// Create cookie (overwrites existing)
			setcookie ('OekakiU', $row['usrname'], time() + $cookie_life, $cookie_path);
			setcookie ('OekakiPass', $usrpass3, time() + $cookie_life, $cookie_path);
			all_done('index.php;in');
		} else {
			report_err($langop_functions_err13);
		}
	}
}

// Logoff (from header.php)
if ($mode == 'logoff') {
	// Kill all cookies
	$scratch = mktime (12, 0, 0, 1, 1, 1970);
	setcookie ('OekakiU', '', $scratch, $cookie_path);
	setcookie ('OekakiPass', '', $scratch, $cookie_path);

	// Take user off online list
	$online = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakionline WHERE onlineusr='$OekakiU'");

	all_done('index.php;out');
}



// ==================================================================
// Begin functions.php
//

// Mass OPMail
if ($action == 'massmail') {
	$send_to = slashit($_POST['send_to']);
	$body    = slashit($_POST['body']);
	$subject = slashit(html_chars_wac ($_POST['subject']));

	if ($flags['owner']) {
		// To whom do we send the messages?
		$sql_where = "WHERE usrflags != 'P'";
		if ($send_to != 'member') {
			if ($send_to == 'A') {
				$sql_where = "WHERE rank >= ".RANK_ADMIN;
			} else {
				$sql_where = "WHERE usrflags LIKE '%{$send_to}%'";
			}
		}

		if (!empty ($send_to) && !empty ($OekakiU)) {
			if (empty ($subject)) {
				report_err($langop_functions_err1);
			}
			$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_MemberPrefix}oekaki ".$sql_where);
			if ($result) {
				while ($row = mysql_fetch_array ($result)) {
					$result3 = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakimailbox SET sender='$OekakiU', reciever='{$row['usrname']}', subject='$subject', body='$body', senddate=NOW()");
				}
			}
		}
		all_done('mailbox.php');
	} else {
		report_err($langop_functions_err2);
	}
}



// Archive picture
if ($mode == 'archive') {
	$picid = (int) $_GET['picid'];

	if ($flags['admin']) {
		// Get archive flag
		$result = mysql_query ("SELECT archive FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID=$picid");

		if ($result) {
			// Toggle archive status
			$archive = (int) mysql_result ($result, 0);
			$archive ? $archive = 0 : $archive = 1;

			$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET archive=$archive WHERE PIC_ID=$picid");
		}
		all_done('index.php'.$pic_redirect.'#'.$picid);
	} else {
		report_err($langop_functions_err3);
	}
}



// Lost Password Send
if ($action == 'pretrieve') {
	$username = slashit($_POST['username']);

	$result = mysql_query ("SELECT usrpass, email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");
	$numrows = mysql_num_rows ($result);

	if ($numrows != 0) {
		$row = mysql_fetch_array ($result);

		$mail_header = "From: \"OekakiPoteto Admin\" <{$cfg['op_email']}>\nX-Mailer: Wacintaki BBS\n";
		$mail_subject = $cfg['op_title'].' '.$langop_precover_title;
		$mail = "{$langop_word_dear} {$username},\n\n{$langop_precover_p1} [{$address} / {$hostname}] {$langop_precover_p2} {$cfg['op_title']} @ {$cfg['op_url']}. {$langop_precover_p3}:\n\n{$cfg['op_url']}/chngpass.php?vcode={$row['usrpass']}&username=".urlencode($username)."\n\n{$langop_precover_p4}\n\n{$langop_precover_p5}";

		if (CUT_EMAIL < 2) {
			$mail_sent = @mail ($row['email'], $mail_subject, $mail, $mail_header);
		}

		if (!$mail_sent) {
			report_err('Sorry, the BBS e-mailer isn\'t working. Ask an admin to reset your password.');
		}
		all_done();
	} else {
		report_err($langop_functions_err4);
	}
}



// Password Reset
if ($action == 'pass_reset') {
	$usrname2 =  slashit($_POST['usrname2']);
	$new_pass =  slashit(trim ($_POST['new_pass']));
	$new_pass2 = slashit(trim ($_POST['new_pass2']));

	if ($flags['owner']) {
		if (empty ($new_pass) || empty ($usrname2)) {
			report_err('New password is invalid');
		}
		if ($new_pass != $new_pass2) {
			report_err('Password verification failed. Make sure the new password is typed properly in both fields');
		}
		if ($bad = badChars(stripslashes ($new_pass))) {
			report_err('New password contains illegal characters: '.make_list($bad, ', ', '"'));
		}

		// I am the Crypt Keyper!
		$crypt_pass = crypt ($new_pass, $cfg['salt']);
		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrpass='$crypt_pass' WHERE usrname='$usrname2'");

		if (!$result) {
			report_err('New password could not be set due to a database error. Try again');
		}
	} else {
		report_err('You do not have the credentials to access the password reset.');
	}

	all_done();
}



// Lost Password Change
if ($action == 'pchange') {
	$username = slashit($_POST['username']);
	$vcode    = slashit($_POST['vcode']);
	$newpass  = slashit($_POST['newpass']);
	$retype   = slashit($_POST['retype']);

	$result = mysql_query ("SELECT * FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");
	$numrows = mysql_num_rows ($result);

	if ($numrows != 0) {
		$row = mysql_fetch_array ($result);

		// Compare the existing password against the database
		if ($row['usrpass'] == $vcode) {
			// Compare the new password with the old
			if ($newpass == $retype) {
				if ($bad = badChars(stripslashes ($newpass))) {
					report_err('New password contains illegal characters: '.make_list($bad, ', ', '"'));
				}

				// Change the password
				$newpass = crypt ($newpass, $cfg['salt']);
				$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrpass='$newpass' WHERE usrname='$username'");

				// Logout
				$scratch = mktime (12, 0, 0, 1, 1, 1970);
				setcookie ('OekakiU', '', $scratch, $cookie_path);
				setcookie ('OekakiPass', '', $scratch, $cookie_path);

				// Take user off online list
				$online = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakionline WHERE onlineusr='$OekakiU'");

				all_done('index.php;out');
			} else {
				report_err($langop_functions_err5);
			}
		} else {
			report_err($langop_functions_err6);
		}
	} else {
		report_err($langop_functions_err7);
	}
}



// Mailbox Send
if ($action == 'mailsend') {
	$body     = slashit(html_chars_wac($_POST['body']));
	$subject  = slashit(html_chars_wac($_POST['subject']));
	$reciever = slashit($_POST['reciever']);
	$MID      = (int) $_POST['MID'];

	if (!empty ($OekakiU) && $flags['G']) {
		if (empty ($subject)) {
			report_err($langop_functions_err8);
		}

		$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$reciever}'");
		$numrows = mysql_num_rows ($result);

		if ($numrows != 0) {
			$row = mysql_fetch_array ($result);

			if ($_POST['reply'] == '1') {
				$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekakimailbox SET mstatus={$mail_status['replied']} WHERE MID='{$MID}'");
			}
			$result = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakimailbox SET sender='{$OekakiU}', reciever='".addslashes ($row['usrname'])."', subject='{$subject}', body='{$body}', senddate=NOW()");

			all_done('mailbox.php');
		} else {
			report_err($langop_functions_err9);
		}
	} else {
		report_err($langop_functions_err10);
	}
}



// Mailbox Check Delete
if ($action == 'mail_check_delete') {
	if (isset ($_POST['MD'])) {
		foreach ($_POST['MD'] as $mid) {
			$MID = (int) $mid;

			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakimailbox WHERE MID='{$mid}' AND reciever='{$OekakiU}'");
		}
	}

	all_done('mailbox.php');
}



// Mailbox Delete
// (mailread.php)
if ($_GET['mode'] == 'maildelete') {
	$MID = (int) $_GET['MID'];

	$result = mysql_query ("SELECT * FROM {$OekakiPoteto_MemberPrefix}oekakimailbox WHERE MID='{$MID}'");
	$row = mysql_fetch_array ($result);

	if ($row['reciever'] != $OekakiU) {
		report_err($langop_functions_err11);
	} else {
		$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakimailbox WHERE MID='{$MID}'");
		all_done('mailbox.php');
	}
}



// User delete
if ($action == 'deluser') {
	$usrname2  = (int) $_POST['usrname2']; // ID, not name!
	$confirm   = (int) $_POST['confirm'];
	$no_reason = (int) $_POST['no_reason'];
	$reason    = slashit(trim ($_POST['reason']));

	if ($flags['sadmin']) {
		// Get e-mail of admin that deleted user
		$result2 = mysql_query ("SELECT email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$OekakiU'");
		$row = mysql_fetch_array ($result2);

		if ($confirm == 1) {
			// Pic delete routine
			include ('paintsave.php');

			// Initiate delete
			$result = mysql_query ("SELECT ID, usrname, email, avatar FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE ID='$usrname2'");
			$row2 = mysql_fetch_array ($result);
			$row2['usrname'] = addslashes ($row2['usrname']);

			// Remove images
			$result = mysql_query ("SELECT PIC_ID FROM {$OekakiPoteto_Prefix}oekakidta WHERE usrname='{$row2['usrname']}'");
			while ($result && ($kill_me = mysql_fetch_array ($result))) {
				kill_picture_slot($kill_me['PIC_ID']);
			}

			// Remove avatar
			if (!empty ($row2['avatar'])) {
				@unlink ($cfg['avatar_folder'].'/'.$row2['avatar']);
			}

			// Goodbye
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakionline WHERE onlineusr='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE usrname='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakichat WHERE usrname='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekakimailbox WHERE reciever='{$row2['usrname']}'");
			$result = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE ID='{$row2['ID']}'");

			// Send e-mail
			if ($no_reason != 1) {
				$mail_header = "From: \"OekakiPoteto Admin\" <{$cfg['op_email']}>\nX-Mailer: Wacintaki BBS\n";
				$mail_subject = $cfg['op_title'].' '.$langop_mandel_title;
				$mail = "{$langop_word_dear} {$row2['usrname']},\n\n{$langop_mandel_p1} {$cfg['op_title']} @ {$cfg['op_url']}. {$langop_mandel_p3}.\n\n{$cfg['op_title']} {$langop_word_admin}\n{$langop_mandel_p2}: {$OekakiU} ({$row['email']})\n{$langop_word_comments}: {$reason}";

				if (CUT_EMAIL < 2) {
					$mail_sent = @mail ($row2['email'], $mail_subject, $mail, $mail_header);
				}

				if (!$mail_sent) {
					report_err('User deleted, but e-mailer isn\'t working. Notify user manually at <a href="mailto:'.$row2['email'].'">'.$row2['email'].'</a>.');
				}
			}
		}
	} else {
		report_err($langop_functions_err12);
	}
	all_done('delusr.php');
}



// Registration Verification
if ($mode == 'Verify') {
	$username = slashit($_GET['username']);
	$vcode    = slashit($_GET['vcode']);

	if ($cfg['approval'] == 'yes') {
		all_done();
	}

	// Get user info
	$result = mysql_query ("SELECT usrname, usrpass, usrflags, email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$username}'");
	$row = mysql_fetch_array ($result);

	if ($vcode == $row['usrpass'] && $row['usrflags'] == 'P') {
		$theflags = 'G';
		$permissions = $langop_type_guser."\n";
	
		if ($cfg['reg_draw'] == 'yes') {
			$theflags .= 'D';
			$permissions .= $langop_type_daccess."\n";
		}
		if ($cfg['reg_anim'] == 'yes') {
			$theflags .= 'M';
			$permissions .= $langop_type_aaccess."\n";
		}
		if ($cfg['reg_upload'] == 'yes') {
			$theflags .= 'U';
			$permissions .= 'Upload Access'."\n";
		}

		// Insert user with automatic acceptance and draw permissions
		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='{$theflags}' WHERE usrname='{$username}'");

		// Set cookies
		setcookie ('OekakiU', $row['usrname'], time() + $cookie_life, $cookie_path);
		setcookie ('OekakiPass', $row['usrpass'], time() + $cookie_life, $cookie_path);

		// Send e-mail
		$mail_subject = $cfg['op_title'].' '.$langop_autoreg_title;
		$mail = "{$langop_word_dear} {$row['usrname']},\n\n{$langop_autoreg_p1} {$cfg['op_title']} @ {$cfg['op_url']} {$langop_autoreg_p2}\n\n{$langop_autoreg_p3}:\n{$permissions}\n{$langop_autoreg_p4}\n\n{$cfg['op_title']} {$langop_word_admin}\n{$langop_autoreg_p5}";
		$mail_header = "From: \"OekakiPoteto Admin\" <{$cfg['op_email']}>\nX-Mailer: Wacintaki BBS\n";

		if (CUT_EMAIL < 1) {
			$mail_sent = @mail ($row['email'], $mail_subject, $mail, $mail_header);
		}

		all_done('editprofile.php;in');
	} else {
		report_err($langop_functions_err14);
	}
}



// Registration (from register.php)
if ($action == 'register') {
	$username = slashit($_POST['username']);
	$email    = slashit(html_chars_wac($_POST['email']));
	$age      = decode_birthday($_POST['age_year'], $_POST['age_month'], $_POST['age_day']);
	$pass     = slashit($_POST['pass']);
	$pass2    = slashit($_POST['pass2']);
	$artURL   = slashit(html_chars_wac($_POST['artURL']));
	$comment  = slashit(html_chars_wac($_POST['comments']));

	//Spam test
	//$x_test = (int) $_POST['x_test'];
	//$y_test = (int) $_POST['y_test'];
	//$e_test = (int) $_POST['e_test'];
	//if ($x_test + $y_test != $e_test || $e_test < 2) {
	//	exit ('Humanity test failed.');
	//}

	if (empty ($username)) {
		all_done();
	}

	if ($cfg['op_adult'] == 'yes') {
		if (intval ($_POST['age_year']) < 1900) {
			report_err('You must submit a valid age declaration (birth year).');
		}
	}

	// Prevent database from vomiting
	if ($bad = badChars(stripslashes ($username))) {
		report_err('Your user name contains illegal characters: '.make_list($bad, ', ', '"'));
	}
	$trimpass = trim ($pass);
	if (empty ($trimpass)) {
		report_err('You must enter a password');
	}
	if ($bad = badChars(stripslashes ($pass))) {
		report_err('Your password contains illegal characters: '.make_list($bad, ', ', '"'));
	}
	if ($cfg['require_art'] == 'yes') {
		if (empty ($artURL) || strlen ($artURL) < 8 || strstr ($artURL, '<')) {
			// ('<' filters out IMG tags, etc)
			report_err('A valid URL is required to register on this BBS');
		}
	}
	if ($cfg['op_adult'] == 'yes' && empty ($age)) {
		report_err('You must declare your age to register on this BBS');
	}


	// Check if a member already exists
	$result = mysql_query ("SELECT usrname, email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$username'");
	if ($result && mysql_num_rows ($result) > 0) {
		report_err('Member name already exists!');
	}

	// Check for duplicate e-mail
	//$result = mysql_query ("SELECT usrname, email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE email='$email'");
	//$row = mysql_fetch_array ($result);
	//if ($username == $row['usrname']) {
	//	report_err($langop_functions_err15);
	//}


	// Check if the passwords match
	$userpass1 = crypt ($pass, $cfg['salt']);
	if ($pass == $pass2) {
		// Add the user as pending
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekaki SET usrname='{$username}', email='{$email}', usrpass='{$userpass1}', age='{$age}', usrflags='P', comment='{$comment}', url='{$artURL}', joindate=NOW(), language='', templatesel='', avatar='', lastlogin=NOW()");

		$mail_sent = FALSE;
		if ($cfg['approval'] == 'no') {
			// Send an email for verification
			$mail_subject = $cfg['op_title'].' '.$langop_verreg_title;
			$mail = "{$langop_word_dear} {$username},\n\n{$langop_verreg_p1} {$cfg['op_title']} @ {$cfg['op_url']}. {$langop_verreg_p2}:\n\n{$cfg['op_url']}/functions.php?mode=Verify&vcode={$userpass1}&username=".urlencode($username)."\n\n{$langop_verreg_p3}\n\n{$langop_precover_p5}";
			$mail_header = "From: \"OekakiPoteto Admin\" <{$cfg['op_email']}>\nX-Mailer: Wacintaki BBS\n";

			if (CUT_EMAIL < 1) {
				$mail_sent = @mail ($email, $mail_subject, $mail, $mail_header);
			}
		}

		if (!$mail_sent) {
			if ($cfg['approval'] == 'force') {
				// Auto-approve
				$theflags = 'G';
				if ($cfg['reg_draw'] == 'yes')
					$theflags .= 'D';
				if ($cfg['reg_anim'] == 'yes')
					$theflags .= 'M';
				if ($cfg['reg_upload'] == 'yes')
					$theflags .= 'U';

				$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='{$theflags}' WHERE usrname='{$username}'");
			} else {
				// D'OH!
				report_err('Sorry, the BBS e-mailer isn\'t working. You\'ll have to wait for your application to be approved.');
			}
		}
	} else {
		report_err($langop_functions_err5);
	}

	all_done('register.php?rules=2');
}



// User Flag Modification (from modflags.php)
if ($action == 'modflags') {
	$usrname2 = slashit($_POST['usrname2']);
	$new_rank = (int) $_POST['rank'];

	if (!$flags['admin']) {
		report_err('You cannot access flag modification');
	}

	$result = mysql_query ("SELECT usrname, usrflags, usrpass, rank FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$usrname2'");
	$their_info = mysql_fetch_array ($result);


	// Hack check.  No error reporting.
	if (!$flags['owner']) {
		if ($new_rank >= $flags['rank']) {
			// Don't let admins upgrade own rank or overpromote
			$new_rank = $their_info['rank'];
		}
	} elseif ($OekakiU == $usrname2) {
		// Don't let owners lose own flags
		$new_rank = $their_info['rank'];
	}

	// Admin flag overrides
	if ($new_rank >= RANK_ADMIN) {
		$_POST['upload_user'] = 'U';
		$_POST['immunity'] = 'I';
	}

	$new_flags =
		$_POST['general'].
		$_POST['draw_user'].
		$_POST['anim_user'].
		$_POST['upload_user'].
		$_POST['adult_user'].
		$_POST['immunity'];


	// Update DB
	$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='$new_flags' WHERE usrname='$usrname2'");
	if (!$result) {
		report_err('Flags could not be set due to a database error. Try again');
	}

	if ($new_rank != $their_info['rank']) {
		$result2 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET rank='$new_rank' WHERE usrname='$usrname2'");
		if (!$result2) {
			report_err('Rank could not be set due to a database error. Try again');
		}
	}

	all_done('modflags.php');
}



// Add/Remove User (from addusr.php)
if ($action == 'adduser') {
	$usrname2      = slashit($_POST['usrname2']);
	$draw_access   = (int) $_POST['reg_draw'];
	$anim_access   = (int) $_POST['reg_anim'];
	$upload_access = (int) $_POST['reg_upload'];
	$accept        = (int) $_POST['accept'];
	$reason        = slashit(html_chars_wac($_POST['reason']));

	// Admins only
	if (!$flags['admin']) {
		report_err($langop_functions_err17);
	}

	// Get admin e-mail
	$result = mysql_query ("SELECT email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$OekakiU}'");
	$adminEmail = mysql_result ($result, 0);

	// Get user e-mail
	$result = mysql_query ("SELECT email FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='{$usrname2}'");
	$their_email = mysql_result ($result, 0);

	if ($accept == 1) {
		$theflags = 'G';
		$permissions = $langop_type_guser."\n";
	
		if ($draw_access == 1) {
			$theflags .= 'D';
			$permissions .= $langop_common_drawacc."\n";
		}
		if ($anim_access == 1) {
			$theflags .= 'M';
			$permissions .= $langop_common_aniacc."\n";
		}
		if ($upload_access == 1) {
			$theflags .= 'U';
			$permissions .= 'Upload Access'."\n";
		}

		$result2 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='{$theflags}' WHERE usrname='{$usrname2}'");

		if (!empty ($their_email) && strpos ($their_email, '@')) {
			// Send e-mail
			$mail_subject = $cfg['op_title'].' '.$langop_autoreg_title;
			$mail = "{$langop_word_dear} {$usrname2},\n\n{$langop_autoreg_p1} {$cfg['op_title']} @ {$cfg['op_url']} {$langop_autoreg_p2}\n\n{$langop_autoreg_p3}:\n{$permissions}\n{$langop_autoreg_p4}\n\n{$cfg['op_title']} {$langop_word_admin}\n{$langop_common_approvby}: {$OekakiU} ({$adminEmail})\n{$langop_word_comments}: {$reason}";
			$mail_header = "From: \"{$langop_precover_p5}\" <{$cfg['op_email']}>\nX-Mailer: Wacintaki BBS\n";

			$mail_sent = FALSE;
			if (CUT_EMAIL < 1) {
				$mail_sent = @mail ($their_email, $mail_subject, $mail, $mail_header);
			}

			if (!$mail_sent) {
				report_err('Note:  user was approved, but could not be e-mailed.');
			}

			all_done('addusr.php');
		} else {
			report_err('User was approved, but could not be e-mailed due to an invalid e-mail address.');
		}
	} else {
		$result2 = mysql_query ("DELETE FROM {$OekakiPoteto_MemberPrefix}oekaki WHERE usrname='$usrname2'");

		if (!empty ($their_email) && strpos ($their_email, '@')) {
			// Send e-mail
			$mail_subject = $cfg['op_title'].' '.$langop_autoreg_title;
			$mail = "{$langop_word_dear} {$usrname2},\n\n{$langop_rejmsg_p1} {$cfg['op_title']} @ {$cfg['op_url']}, {$langop_rejmsg_p2} {$cfg['op_title']} {$langop_rejmsg_p3}\n\n{$cfg['op_title']} {$langop_word_admin}\n {$langop_common_rejby}: {$OekakiU} ({$adminEmail})\n{$langop_word_comments}: {$reason}";
			$mail_header = "From: \"OekakiPoteto Admin\" <{$cfg['op_email']}>\nX-Mailer: Wacintaki BBS\n";

			$mail_sent = FALSE;
			if (CUT_EMAIL < 2) {
				$mail_sent = @mail ($their_email, $mail_subject, $mail, $mail_header);
			}

			if (!$mail_sent) {
				report_err('User was rejected, but could not be e-mailed. Notify user manually at <a href="mailto:'.$their_email.'">'.$their_email.'</a>.');
			}

			all_done('addusr.php');
		} else {
			report_err('User was removed, but could not be e-mailed due to an invalid e-mail address.');
		}
	}
}



// Profile Edit
if ($action == 'editprofile') {
	$name       = slashit(html_chars_wac($_POST['name']));
	$email      = slashit(html_chars_wac($_POST['email']));
	$age        = decode_birthday ($_POST['age_year'], $_POST['age_month'], $_POST['age_day']);
	$gender     = slashit(html_chars_wac($_POST['gender']));
	$location   = slashit(html_chars_wac($_POST['location']));
	$url        = slashit(html_chars_wac($_POST['url']));
	$urltitle   = slashit(html_chars_wac($_POST['urltitle']));
	$aim        = slashit(html_chars_wac($_POST['aim']));
	$icq        = slashit(html_chars_wac($_POST['icq']));
	$msn        = slashit(html_chars_wac($_POST['msn']));
	$yahoo      = slashit(html_chars_wac($_POST['yahoo']));
	$ircserver  = slashit(html_chars_wac($_POST['ircserver']));
	$ircnick    = slashit(html_chars_wac($_POST['ircnick']));
	$ircchan    = slashit(html_chars_wac($_POST['ircchan']));
	$language2  = slashit(html_chars_wac($_POST['language2']));
	$ctemplate  = slashit(html_chars_wac($_POST['ctemplate']));
	$picview    = (int) $_POST['picview'];
	$adult      = $_POST['adult'];
	$comment    = slashit(html_chars_wac($_POST['comment']));
	$username2  = slashit($_POST['username2']);
	$oldpass    = slashit($_POST['oldpass']);
	$passwd     = slashit($_POST['passwd']);
	$passwdnew  = slashit($_POST['passwdnew']);
	$thumbview  = (int) $_POST['thumbview'];
	$screensize = (int) $_POST['screensize'];

	// Test username
	$test = trim ($username2);
	if (empty ($test) || $OekakiU != $username2) {
		// Profile mismatch
		all_done();
	}

	// Add adult flag
	$trueflags = str_replace ('X', '', $flags['all']);
	if ($adult == 'X') {
		$trueflags .= 'X';
	}

	// Add info to database
	$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET name='{$name}', url='{$url}', comment='{$comment}', email='{$email}', aim='{$aim}', icq='{$icq}', urltitle='{$urltitle}', MSN='{$msn}', yahoo='{$yahoo}', IRCserver='{$ircserver}', IRCnick='{$ircnick}', usrflags='{$trueflags}', location='{$location}', templatesel='{$ctemplate}', IRCchan='{$ircchan}',age='{$age}', gender='{$gender}', picview='{$picview}', thumbview='{$thumbview}', screensize='{$screensize}', language='{$language2}' WHERE usrname='$OekakiU'");

	// Update passwords (do this last!)
	if (!empty ($oldpass)) {
		$oldpass2 = crypt ($oldpass, $cfg['salt']);
		if ($oldpass2 == $OekakiPass) {
			if ($passwd == $passwdnew) {
				$passenc = crypt ($passwd, $cfg['salt']);
				$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrpass='{$passenc}' WHERE usrname='{$OekakiU}'");
			} else {
				report_err('New passwords do not match. Please type them again.');
			}
		}
	}

	all_done();
}



// Edit Ban List
if ($action == 'banedit') {
	$ipban   = trim ($_POST['ipban']);
	$hostban = trim ($_POST['hostban']);

	if ($flags['admin']) {
		$fail = 0;
		$hostfail = '';
		$ipfail = '';

		if ($fd = @fopen ($cfg['res_path'].'/hosts.txt', 'w')) {
			fwrite ($fd, $hostban);
			fclose ($fd);
		} else {
			$fail++;
			$hostfail = 'hosts.txt';
		}
		if ($fd2 = @fopen ($cfg['res_path'].'/ips.txt', 'w')) {
			fwrite ($fd2, $ipban);
			fclose ($fd2);
		} else {
			$fail++;
			$ipfail = 'ips.txt';
		}

		if ($fail == 1) {
			report_err('Could not write to '.$hostfail.$ipfail.' file');
		} elseif ($fail == 2) {
			report_err('Could not write to files: '.$hostfail.' and '.$ipfail);
		}
	}
	all_done();
}



// Edit notices
if ($action == 'editnotice') {
	// NOTE: slashit() then stripslashes() ensures that "\n" and other escape codes are preserved!
	$banneredit = stripslashes (slashit($_POST['banneredit']));
	$newsedit   = stripslashes (slashit($_POST['newsedit']));

	if ($flags['admin']) {
		if (!$flags['owner']) {
			check_php_code($newsedit);
			check_php_code($banneredit);
		}

		// Write banner
		$fp = @fopen ($cfg['res_path'].'/banner.php', 'w');
		if ($fp) {
			fwrite ($fp, $banneredit);
			fclose ($fp);
		}

		// Write notice
		$fp2 = @fopen ($cfg['res_path'].'/notice.php', 'w');
		if ($fp2) {
			fwrite ($fp2, $newsedit);
			fclose ($fp2);
		}
	}
	all_done();
}



// Edit rules
if ($action == 'editrules') {
	// NOTE: slashit() then stripslashes() ensures that "\n" and other escape codes are preserved!
	$rulesedit = stripslashes (slashit($_POST['rulesedit']));

	if ($flags['admin']) {
		if (!$flags['owner']) {
			check_php_code($rulesedit);
		}

		// Write rules
		$fp = @fopen ($cfg['res_path'].'/rules.php', 'w');
		if ($fp) {
			if (!empty ($rulesedit)) {
				fwrite ($fp, $rulesedit);
			} else {
				fwrite ($fp, "<p>\n{$langop_defrulz}\n</p>\n");
			}
			fclose ($fp);
		}
	}
	all_done('showrules.php');
}



// Upload picture
if ($_POST['action'] == 'upload') {
	$title         = slashit (html_chars_wac ($_POST['title']));
	$comment       = slashit (html_chars_wac ($_POST['comment']));
	$time_invested = $_POST['edittime'];

	require ('paintsave.php');

	// Seconds hack
	if (strstr (strtolower ($time_invested), 's')) {
		$time_invested = intval ($time_invested);
	} else {
		$time_invested = intval ($time_invested) * 60;
	}

	if ( !($flags['admin'] || $flags['U']) ) {
		report_err('You do not have the credentials to upload pictures.');
	}

	// Verify upload name
	if (!empty ($_POST['usrname']) && $flags['admin']) {
		$upload_name = $_POST['usrname'];
	} else {
		$upload_name = $OekakiU;
	}

	// Size cap.  Just an anti-spammer cap for now
	if ($_FILES['picture']['size'] > $cfg['max_pic']) {
		report_err('Picture too large!  Max size is '.$cfg['max_pic'].' bytes.');
	}


	// Collect picture
	if ($_FILES['picture']['error'] > 0 || empty ($_FILES['picture']['tmp_name'])) {
		if ($_FILES['picture']['error'] == UPLOAD_ERR_NO_FILE) {
			report_err('No picture data was received. Try again.');
		}
		report_err('An error occured while uploading. Try again.');
	}
	$buffer = file_get_contents ($_FILES['picture']['tmp_name']);


	// Collect animation if it exists
	$have_animation = 0;
	if ($_FILES['animation']['tmp_name']) {
		if ($_FILES['animation']['error'] == 0) {
			$anim_ext = strtolower (substr ($_FILES['animation']['name'], -3));
			if ($anim_ext == 'oeb' || $anim_ext == 'pch') {
				$buffer2 = file_get_contents ($_FILES['animation']['tmp_name']);
				$have_animation = 1;
			} else {
				$have_animation = 0;
				$anim_fail = 1;
			}
		}
	}


	// Check filetype
	// We'll have to assume anim data is valid, since pch has no headers
	$type = get_filetype($buffer);

	if ($type == 'bmp') {
		report_err('Picture is a Microsoft BMP file, which is not supported.');
	} elseif ($type == 'jp2') {
		report_err('JPEG2000 is not yet supported, as no oekaki applets used by Wacintaki can read it.');
	} elseif ($type == 'psd') {
		report_err('Picture is a Photoshop file, which is not supported.');
	} elseif ($type == 'zip') {
		report_err('Archives of pictures (ZIP/JAR files) are not supported.');
	} elseif ($type != 'png' && $type != 'jpg' && $type != 'gif') {
		report_err('Picture is an unsupported filetype.');
	}


	// Pic checks out, so reserve a slot
	$resno = get_new_picnumber();
	if ($resno == 0) {
		error_log (__FILE__.': Cannot allocate new PIC_ID for upload.');
		report_err('Unable to allocate a new picture slot for upload!');
	}

	// Cleanup slots
	$result = clean_picture_slots();

	// Insert new slot
	$tries = 5;
	while ($tries > 0) {
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='{$upload_name}', postdate=NOW(), hostname='$hostname', PIC_ID='$resno', IP='$address', datatype='{$_POST['dtype']}', edittime='$time_invested', animation='$have_animation'");

		if ($result) {
			$tries = 0;
		} else {
			$tries--;
			sleep (1);
		}
	}
	if (!$result) {
		error_log ('Upload failed: Picture='.$p_prefix.$resno.'.'.$slot['ptype'].'; Owner='.$OekakiU.'; DB: '.mysql_error());
		report_err('Could not insert picture into database.');
	}

	// Upload OK.  Add member piccount
	$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=(piccount + 1) WHERE usrname='$OekakiU'");

	// Write file(s)
	if ($fail != 1) {
		// Filetype is automatic!
		if (!save_image ($buffer, $resno)) {
			error_log (__FILE__.": Cannot save uploaded image.  User: $OekakiU, Number: $resno");
			$fail = 1;
		}
		if ($have_animation) {
			if (!save_anim ($buffer2, $resno, $anim_ext)) {
				error_log (__FILE__.": Cannot save uploaded animation.  User: $OekakiU, Number: $resno");
				$have_animation = 0;
				$anim_fail = 1;
			}
		}
	} else {
		report_err('Could not insert picture into database.');
	}

	// File data is set, let's add the comments
	if ($_POST['uploadby'] == 1 || !$flags['admin']) {
		if (trim ($comment) == '') {
			$comment = '(Uploaded by [b]'.$OekakiU.'[/b])';
		} else {
			$comment .= "\n\n".'(Uploaded by [b]'.$OekakiU.'[/b])';
		}
	}
	$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET comment='$comment', hostname='$hostname', IP='$address', title='$title', adult='{$_POST['adult']}', postlock='1' WHERE PIC_ID='$resno'");

	all_done();
}



// First post normal pic
if ($action == 'res_msg') {
	$picno      = (int) $_POST['picno'];
	$name       = slashit($_POST['name']);
	$email      = slashit(html_chars_wac ($_POST['email']));
	$url        = slashit(html_chars_wac ($_POST['url']));
	$adult      = $_POST['adult'];
	$title      = slashit (html_chars_wac ($_POST['title']));
	$comment    = slashit (html_chars_wac ($_POST['comment']));
	$share      = (int) $_POST['share'];
	$share_pass = slashit (trim ($_POST['share_pass']));
	$wip        = (int) $_POST['wip'];
	$trans_pass = slashit (trim ($_POST['trans_pass']));

	$result = mysql_query ("SELECT usrname, password, postlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID=$picno");
	if (!$result) {
		report_err('Database error. Try using <a href="recover.php">picture recovery</a>.');
	}
	$old_pic_info = mysql_fetch_array ($result);

	// Check all passwords
	if ((!empty ($OekakiU) && $OekakiU == $old_pic_info['usrname']) || $trans_pass == $old_pic_info['password']) {
		// Check immunity flag for addition
		if ($cfg['draw_immune'] == 'yes' && !$flags['I']) {
			$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET usrflags='{$flags['all']}I' WHERE usrname='{$old_pic_info['usrname']}'");
		}

		//
		// Share code
		// Sharing based exclusively on format of password
		switch ($share) {
			case 2:
				$share_pass = 'public';
				break;
			case 1:
				// Limit password to 12 chars
				// Safe clip, just in case autoslashes is on
				$share_pass = stripslashes ($share_pass);
				$share_pass = addslashes (substr ($share_pass, 0, 12));
				break;
			case 0:
				$share_pass = '';
		}
		if ($cfg['public_retouch'] != 'yes')
			$share_pass = '';

		//
		// WIP code.
		// Should pic be posted?
		//
		$wip ? $lock_stat = 0 : $lock_stat = 1;

		//
		// Bump code
		//
		$bump_me = '';
		if ($old_pic_info['postlock'] == 0) {
			// WIP pictures should always be bumped on edit/post
			$bump_me = ', postdate=NOW()';
		}
		if (($cfg['self_bump'] == 'yes' && $_POST['bump'])) {
			// Self-bump
			$bump_me = ', postdate=NOW()';
		}

		//
		// Update DB
		$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET comment='$comment', hostname='$hostname', IP='$address', title='{$title}', adult='$adult', postlock='{$lock_stat}', password='{$share_pass}'{$bump_me} WHERE PIC_ID='{$picno}'");

		// If not a safety save, inc pic count
		if ($lock_stat) {
			$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=(piccount + 1) WHERE usrname='$OekakiU'");
		}

		// Report safety save
		if ($wip) {
			all_done('comment.php?wipok=1');
		} else {
			all_done();
		}
	} else {
		report_err($langop_functions_err18);
	}
}



// Comment Post
if ($action == 'add') {
	$picno   = (int) $_POST['picno'];
	$pageno  = (int) $_POST['pageno'];
	$name    = slashit($_POST['name']);
	$email   = slashit(html_chars_wac ($_POST['email']));
	$url     = slashit(html_chars_wac ($_POST['url']));
	$comment = slashit(html_chars_wac ($_POST['comment']));
	$uts     = (int) $_POST['uts'];

	if (empty ($OekakiU)) {
		// Anti-spam for guests

		if ($cfg['guest_post'] != 'yes')
			all_done();

		// Referral test
		$cur_time = time();
		if ($uts < $cur_time - 36000 || $uts > $cur_time + 3600) {
			// PHP needs HTTP header *and* status
			header('HTTP/1.0 404 Not Found');
			header('Status: 404 Not Found');
			exit();
		}

		// Run lame anti-spam test
		$comment2 = strtolower ($comment);
		if (strpos ($comment2, '[url=') !== FALSE || strpos ($comment2, '&lt;a href=') !== FALSE) {
			header ('Content-type: text/plain');
			exit ('BBCode unsupported.  Use NiftyToo instead.');
		}

		// Count number of links (default is 2)
		$max_guest_links = 2;
		if (defined ('MAX_GUEST_LINKS')) {
			$max_guest_links = MAX_GUEST_LINKS;
		}
		if ($max_guest_links < 1) {
			header ('Content-type: text/plain');
			exit ('Links disabled for guests.');
		}
		$count = count (explode("p://", $comment2));
		if ($count >= $max_guest_links * 2) {
			header ('Content-type: text/plain');
			exit ('Guests may only post '.$max_guest_links.' links per comment on this board.');
		}
	}

	// Check locked post
	if (!$flags['admin']) {
		$result = mysql_query ("SELECT threadlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
		if (mysql_result ($result, 0) == 1) {
			report_err('You cannot post a comment because the thread is locked');
		}
	}

	// Add comment
	if (!empty ($OekakiU)) {
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakicmt SET usrname='$OekakiU', comment='$comment', hostname='$hostname', postdate=NOW(), PIC_ID='$picno', IP='$address'");
		$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET lastcmt=NOW() WHERE PIC_ID='$picno'");
		$result = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET commcount=(commcount + 1) WHERE usrname='$OekakiU'");

		all_done('index.php'.$pic_redirect.'#'.$picno);
	} else {
		if (empty ($name)) {
			all_done('index.php'.$pic_redirect.'#'.$picno);
		}
		if (strlen ($url) < 8) {
			$url = '';
		}
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakicmt SET usrname='Guest', postname='$name', comment='$comment', hostname='$hostname', email='$email', url='$url', postdate=NOW(), PIC_ID='$picno', IP='$address'");

		setcookie ('guestName',  $name,  time() + $cookie_life, $cookie_path);
		setcookie ('guestEmail', $email, time() + $cookie_life, $cookie_path);
		setcookie ('guestURL',   $url,   time() + $cookie_life, $cookie_path);

		$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET lastcmt=NOW() WHERE PIC_ID='$picno'");

		all_done('index.php'.$pic_redirect.'#'.$picno);
	}
}



// Delete Comment
if ($mode == 'udelcmt' || $mode == 'delcmt') {
	// Note: don't bother with commcount.  It can't be kept accurate.
	$cmtno = (int) $_GET['cmtno'];

	// Get poster
	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakicmt WHERE ID_3='$cmtno'");
	if ($result) {
		$name = mysql_result ($result, 0);

		// Admin only
		if ($name != $OekakiU) {
			if ($flags['admin']) {
				$result4 = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE ID_3='$cmtno'");
				all_done('index.php');
			} else {
				report_err($langop_functions_err19);
			}
		}

		// User
		if (!empty ($OekakiU)) {
			$result4 = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE ID_3='$cmtno'");
			all_done('index.php');
		}
	}
}



// User Pic Delete
if ($action == 'del') {
	$picno = (int) $_POST['picno'];

	if ($_POST['return'] == 'a_match') {
		$returnpage = 'index.php?a_match='.urlencode($OekakiU);
	} else {
		$returnpage = 'index.php';
	}

	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
	$usrname = mysql_result ($result, 0);

	if ($usrname == $OekakiU) {
		include ('paintsave.php');

		kill_picture_slot($picno);

		// Reduce user piccount
		$result4 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=piccount-1 WHERE usrname='{$usrname}'");

		// Reduce board piccount if possible
		$result5 = mysql_query ("SELECT miscvalue FROM {$OekakiPoteto_Prefix}oekakimisc WHERE miscname='piccount'");
		if ($picno > 1 && $picno == mysql_result ($result5, 0)) {
			$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakimisc SET miscvalue=miscvalue-1 WHERE miscname='piccount'");
		}

		all_done($returnpage);
	} else {
		report_err($langop_functions_err20);
	}
}

// Admin Picture Delete (from delconf.php)
if ($action == 'dela') {
	$picno  = (int) $_POST['picno'];
	$reason = slashit(html_chars_wac ($_POST['reason']));
	$givereason = (int) $_POST['givereason'];

	if ($flags['admin']) {
		include ('paintsave.php');

		$result2 = mysql_query ("SELECT usrname, ptype FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
		$row = mysql_fetch_array ($result2);

		// Send reason?
		if ($givereason != 0) {
			if (empty ($reason)) {
				$reason = '(No reason specified)';
			}
			$reason = "{$langop_word_hello},\n\n{$langop_functions_yourpic} (".($cfg['op_url'].'/'.$p_pic.$picno.'.'.$row['ptype']).") {$langop_picdel_p1} {$OekakiU} {$langop_picdel_p2}:\n\n{$reason}\n\n{$langop_picdel_p3}";

			$result = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakimailbox SET sender='$OekakiU', reciever='{$row['usrname']}', subject='$langop_picdel_title', body='$reason', senddate=NOW()");
		}

		kill_picture_slot($picno);

		// Reduce user piccount
		$result4 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=piccount-1 WHERE usrname='{$row['usrname']}'");

		// Reduce board piccount if possible
		$result5 = mysql_query ("SELECT miscvalue FROM {$OekakiPoteto_Prefix}oekakimisc WHERE miscname='piccount'");
		if ($picno > 1 && $picno == mysql_result ($result5, 0)) {
			$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakimisc SET miscvalue=miscvalue-1 WHERE miscname='piccount'");
		}
	}
	all_done('delpics.php');
}



// Recover Pic Delete
if ($action == 'delr') {
	$picno = (int) $_POST['picno'];

	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
	if ($result) {
		$usrname = mysql_result ($result, 0);

		if ($flags['admin'] || $OekakiU == $usrname) {
			$result2 = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
			$result3 = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE PIC_ID='$picno'");

			// Reduce user piccount
			$result4 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=piccount-1 WHERE usrname='{$usrname}'");

			// Reduce board piccount if possible
			$result5 = mysql_query ("SELECT miscvalue FROM {$OekakiPoteto_Prefix}oekakimisc WHERE miscname='piccount'");
			if ($picno > 1 && $picno == mysql_result ($result5, 0)) {
				$result = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakimisc SET miscvalue=miscvalue-1 WHERE miscname='piccount'");
			}

			all_done('recover.php');
		} else {
			report_err('Only an admin may delete this picture.');
		}
	}
	all_done();
}



// Edit Comment
if ($action == 'editcomment'){
	$comment2 = slashit(html_chars_wac ($_POST['comment2']));
	$idno     = (int) $_POST['idno'];
	$editon   = (int) $_POST['editon'];

	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakicmt WHERE ID_3='$idno'");
	if ($result) {
		$usrname = mysql_result ($result, 0);

		if ($usrname != $OekakiU) {
			if ($flags['admin']) {
				if ($editon) {
					$comment2 .= "\n\n(Edited by [b]{$OekakiU}[/b] on ".date('F j, Y, g:i a').')';
				}
			} else {
				report_err($langop_functions_err21);
			}
		} elseif ($editon) {
			$comment2 .= "\n\n({$langop_common_editedon} ".date('F j, Y, g:i a').')';
		}
		$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakicmt SET comment='$comment2' WHERE ID_3='$idno'");
		all_done();
	}
}



// Edit Main Picture Comment
if ($action == 'picedit') {
	$title2    = slashit(html_chars_wac ($_POST['title2']));
	$comment2  = slashit(html_chars_wac ($_POST['comment2']));
	$adult     = (int) $_POST['adult'];
	$picno     = (int) $_POST['picno'];
	$adminedit = $_POST['adminedit'];
	$password  = slashit(trim ($_POST['password']));
	$editon    = (int) $_POST['editon'];

	if (!empty ($password)) {
		// Limit password to 12 chars
		// Safe clip, just in case autoslashes is on
		$password = stripslashes ($password);
		$password = addslashes (substr ($password, 0, 12));
	}

	$result = mysql_query ("SELECT usrname FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID=$picno");
	if ($result) {
		$usrname = mysql_result ($result, 0);

		if ($usrname != $OekakiU) {
			if ($flags['admin']) {
				if ($editon) {
					$comment2 .= "\n\n(Edited by [b]{$OekakiU}[/b] on ".date('F j, Y, g:i a').')';
				}
			} else {
				report_err($langop_functions_err21);
			}
		} elseif ($editon) {
			$comment2 .= "\n\n({$langop_common_editedon} ".date('F j, Y, g:i a').')';
		}
		$result3 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET title='{$title2}', comment='{$comment2}', adult='{$adult}', postlock=1, password='{$password}' WHERE PIC_ID={$picno}");
	}

	all_done();
}



// Lock thread
if ($mode == 'lock' || $mode == 'unlock') {
	$picno  = (int) $_GET['picno'];

	if ($flags['admin']) {
		$result = mysql_query ("SELECT threadlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");

		if ($result) {
			// Toggle lock status
			$lock = (int) mysql_result($result, 0);
			$lock ? $lock = 0 : $lock = 1;

			$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET threadlock='$lock' WHERE PIC_ID='$picno'");
		}
		all_done('index.php'.$pic_redirect.'#'.$picno);
	} else {
		report_err('You must be an admin to lock or unlock threads.');
	}
}


// Block 18+ thread
if ($mode == 'block' || $mode == 'unblock') {
	$picno  = (int) $_GET['picno'];

	if ($flags['admin']) {
		$result = mysql_query ("SELECT adult FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");

		if ($result) {
			// Toggle adult status
			$block = (int) mysql_result ($result, 0);
			$block ? $block = 0 : $block = 1;

			$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET adult='$block' WHERE PIC_ID='$picno'");
		}
		all_done('index.php'.$pic_redirect.'#'.$picno);
	} else {
		report_err('You must be an admin to mark pictures other than yours as adult.');
	}
}


// WIP picture
if ($mode == 'wip_pic') {
	$picno  = (int) $_GET['picno'];

	if ($flags['admin']) {
		$result = mysql_query ("SELECT usrname, postlock FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");

		if ($result) {
			$pic_info = mysql_fetch_array ($result);

			// Toggle WIP status, and bump date
			intval ($pic_info['postlock']) ? $wip = 0 : $wip = 1;
			$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET postlock='$wip', postdate=NOW() WHERE PIC_ID='$picno'");

			// Decrease piccount
			$result2 = mysql_query ("UPDATE {$OekakiPoteto_MemberPrefix}oekaki SET piccount=(piccount-1) WHERE usrname='{$pic_info['usrname']}'");

			// Send mailbox message
			$subject = 'Safety save';
			$message = "One of your pictures has been turned into a safety save by [b]{$OekakiU}[/b].  To finish it, go to the draw screen.  It must be finished within {$cfg['safety_storetime']} days.";
			$result3 = mysql_query ("INSERT INTO {$OekakiPoteto_MemberPrefix}oekakimailbox SET sender='$OekakiU', reciever='{$pic_info['usrname']}', subject='$subject', body='$message', senddate=NOW()");
		}

		all_done('index.php'.$pic_redirect.'#'.$picno);
	} else {
		report_err('Only admins may change safety save status.');
	}
}


// Picture Bump
if ($mode == 'bump') {
	$resno = (int) $_GET['resno'];

	include('paintsave.php');

	if ($flags['admin']) {
		$status = bump_post($resno);
	}
	all_done();
}


/* Force Thumbnail
	$GET_['resno'] = slot
	$GET_['type'] = type (PNG, JPEG)
*/
if ($mode == 'make_thumb') {
	$picno = (int) $_GET['picno'];

	require ('paintsave.php');

	// Hack for NineChime
	$thumb_type = 'jpg';
	if ($_GET['type'] == 'png')
		$thumb_type = 'png';

	
	if ($flags['admin']) {
		// Get status.
		$result3 = mysql_query ("SELECT usethumb, ptype, ttype, rtype FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$picno'");
		$status = mysql_fetch_array ($result3);

		// Purge old
		if (!empty ($status['rtype'])) {
			$result3 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET usethumb=0, rtype='' WHERE PIC_ID='$picno'");
			file_unlock ($r_pic.$picno.'.'.$status['rtype']);
		}
		if (!empty ($status['ttype'])) {
			$result3 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET ttype='' WHERE PIC_ID='$picno'");
			file_unlock ($t_pic.$picno.'.'.$status['ttype']);
		}

		// If "R" thumbnails didn't exist, make them
		if ($status['usethumb'] == 0) {
			save_thumbnail($picno, $status['ptype'], TRUE, $thumb_type);
		}

		all_done('index.php'.$pic_redirect.'#'.$picno);
	} else {
		report_err('Only admins may use this function.');
	}
}



// Uncaught condition
@mysql_close ($dbconn);
header ('Content-type: text/plain');
exit ('No mode.  Is a server filter being used?');

?>